#ifndef INSTANCE_H
#define INSTANCE_H

#include <bits/stdc++.h>


class pos {
  public:
    pos(int x, int y);
    pos();
    int dist2(const pos &b) const;
    int x, y;
};

class warehouse {
  public:
    warehouse(pos p, std::vector<int> disp);
    pos p;
    std::vector<int> disp;
};

class order {
  public:
    order(int id, pos p, std::map<int, int> ord);
    pos p;
    int id;
    std::map<int, int> ord;
    int best_wh;
};

class instance {
  public:
    instance(); // read from stdin
    int row, col, drones, max_load;
    int T; // deadline
    int P; // # products
    int W; // # warehouses
    int C; // # orders
    std::vector<int> weights;
    std::vector<warehouse> wh;
    std::vector<order> orders;
};

#endif
